# $Revision: 1.26 $, $Date: 2011/06/01 20:00:22 $
# TODO:
# - how is it excpected to cooperate with git-daemon?
# - add dedicated system user
%include	/usr/lib/rpm/macros.perl
Summary:	Software for hosting git repositories
Summary(pl.UTF-8):	Narzędzie do hostowania repozytoriów git
Name:		gitolite
Version:	2.0.2
Release:	1
License:	GPL v2
Group:		Development/Tools
Source0:	http://github.com/sitaramc/gitolite/tarball/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	099947faee44ea3b308b5e61f87ddb8e
Patch0:		%{name}-mkdir.patch
Patch1:		%{name}-env.patch
URL:		http://github.com/sitaramc/gitolite
BuildRequires:	perl-Text-Markdown
BuildRequires:	rpm-perlprov
BuildRequires:	rpmbuild(macros) >= 1.219
BuildRequires:	sed >= 4.0
Requires:	git-core
Requires:	openssh-server
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Gitolite allows a server to host many git repositories and provide
access to many developers, without having to give them real userids on
the server. The essential magic in doing this is ssh's pubkey access
and the authorized_keys file, and the inspiration was an older program
called gitosis.

Gitolite can restrict who can read from (clone/fetch) or write to
(push) a repository. It can also restrict who can push to what branch
or tag, which is very important in a corporate environment. Gitolite
can be installed without requiring root permissions, and with no
additional software than git itself and Perl.

%package doc
Summary:	Manual for Gitolite
Summary(fr.UTF-8):	Documentation pour Gitolite
Summary(it.UTF-8):	Documentazione di Gitolite
Summary(pl.UTF-8):	Podręcznik dla Gitolite
Group:		Documentation

%description doc
Documentation for Gitolite.

%description doc -l fr.UTF-8
Documentation pour Gitolite.

%description doc -l it.UTF-8
Documentazione di Gitolite.

%description doc -l pl.UTF-8
Dokumentacja do Gitolite.

%prep
%setup -qc
mv sitaramc-gitolite-*/* .
rm -rf sitaramc-gitolite-*

%patch0 -p1
%patch1 -p1

rm src/gl-system-install

echo %{version} > conf/VERSION
sed -i 's,^# $GL_PACKAGE_CONF =.*,$GL_PACKAGE_CONF = "%{_sysconfdir}/gitolite";,g' conf/example.gitolite.rc
sed -i 's,^# $GL_PACKAGE_HOOKS =.*,$GL_PACKAGE_HOOKS = "%{_datadir}/gitolite/hooks";,g' conf/example.gitolite.rc

# Some ugly hacks. Life without ugly hacks would be so booring.
sed -i 's,^GL_PACKAGE_CONF=.*,GL_PACKAGE_CONF=%{_sysconfdir}/gitolite,g' src/gl-setup
sed -i '2a\GL_ADMIN=$HOME/.gitolite\nGL_BINDIR=%{_bindir}\n' hooks/gitolite-admin/post-update

%build
# Format documentation
for F in doc/*.mkd; do
	perl -MText::Markdown > $(echo $F | sed s/.mkd/.html/) < $F \
		-e '$text=join("",<>); $text=~s#(\[\w+\]: )http://sitaramc.github.com/gitolite/doc/#$1#g;
                    print Text::Markdown::markdown ($text);'
done

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_sysconfdir}/gitolite,%{_datadir}/gitolite/hooks,%{perl_vendorlib}}
cp -a src/gl-* src/sshkeys-lint $RPM_BUILD_ROOT%{_bindir}
cp -p src/*.pm $RPM_BUILD_ROOT%{perl_vendorlib}
cp -p conf/{example.gitolite.rc,VERSION} $RPM_BUILD_ROOT%{_sysconfdir}/gitolite
cp -a hooks/* $RPM_BUILD_ROOT%{_datadir}/gitolite/hooks

%{__rm} $RPM_BUILD_ROOT%{_datadir}/gitolite/hooks/common/{gl-pre-git.hub-sample,update.secondary.sample,post-receive.mirrorpush}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.mkd conf/example.conf hooks/common/{gl-pre-git.hub-sample,update.secondary.sample,post-receive.mirrorpush}

%dir %{_sysconfdir}/gitolite
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/gitolite/example.gitolite.rc
%{_sysconfdir}/gitolite/VERSION
%attr(755,root,root) %{_bindir}/gl-*
%attr(755,root,root) %{_bindir}/sshkeys-lint
%dir %{_datadir}/gitolite
%{perl_vendorlib}/gitolite*.pm
%dir %{_datadir}/gitolite/hooks
%dir %{_datadir}/gitolite/hooks/common
%dir %{_datadir}/gitolite/hooks/gitolite-admin
%attr(755,root,root) %{_datadir}/gitolite/hooks/common/gitolite-hooked
%attr(755,root,root) %{_datadir}/gitolite/hooks/common/update
%attr(755,root,root) %{_datadir}/gitolite/hooks/gitolite-admin/post-update

%files doc
%defattr(644,root,root,755)
%doc doc/*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: gitolite.spec,v $
Revision 1.26  2011/06/01 20:00:22  wiget
- up to 2.0.2
- removed gituser.patch (included in this version)

Revision 1.25  2011/05/17 11:52:53  draenog
- patch from gitolite to set git user and email configuration
- move not necessary hooks in docdir

Revision 1.24  2011/05/17 11:04:39  draenog
- up to 2.0.1

Revision 1.23  2011/05/04 12:58:29  draenog
- remove GIT_* variables from remote environment

Revision 1.22  2011/05/02 13:52:16  draenog
- fix for template directory without hooks subdirectory

Revision 1.21  2011/04/27 16:17:10  draenog
- VERSION file is used by info command

Revision 1.20  2011/04/21 15:30:20  draenog
- BR: openssh-server not openssh-clients

Revision 1.19  2011/04/21 14:27:38  draenog
- change links in documentation to local ones

Revision 1.18  2011/04/20 13:49:40  draenog
- install perl modules in perl_vendorlib (remove lib.patch)
- list %{_sysconfidir}/gitolite only once

Revision 1.17  2011/04/15 18:09:10  wiget
- up to 2.0

Revision 1.16  2011/02/14 11:01:08  wiget
- 1.5.9
- updated lib.patch

Revision 1.15  2011/02/13 12:56:01  glen
- up to 1.5.8, add html docs

Revision 1.14  2010/12/02 14:47:52  pawelz
- script for upgrading lib.patch
- rel 2 (because of fixed patch)

Revision 1.13  2010/12/01 14:53:30  pawelz
- up to 1.5.7

Revision 1.12  2010/06/08 21:11:03  pawelz
- dropped R: htpasswd. It is for additional, optional functionality.

Revision 1.11  2010/06/08 08:50:53  pawelz
- only example.gitolite.rc is config file
- example.conf is more documentation than real conf

Revision 1.10  2010/06/07 17:50:37  pawelz
- R: htpasswd
- dropped comment blindly copied from gitosis.spec
- rel 1

Revision 1.9  2010/06/07 14:40:02  pawelz
- more hacks!!!

Revision 1.8  2010/06/07 14:13:27  pawelz
- add some envs to shell scripts (I'm really interested whether author of this
  crap uses it, or at least whether he tried to run it)
- +x for hooks

Revision 1.7  2010/06/07 13:23:25  pawelz
- fixed perl syntax generated by sed expressions.

Revision 1.6  2010/06/07 13:20:07  sparky
- generate proper perl deps
- avoid /etc/gitolite being listed twice in %files
- a bit more verbose %files

Revision 1.5  2010/06/07 13:16:51  pawelz
- preserve -x of scripts

Revision 1.4  2010/06/07 13:16:25  pawelz
- correct use of sed (-i!)
- one more path to translate
- BR: sed >= 4.0

Revision 1.3  2010/06/07 13:02:13  pawelz
- lib.patch (thx sparky)

Revision 1.2  2010/06/07 12:44:19  pawelz
- dropped Patch0

Revision 1.1  2010/06/07 12:38:19  pawelz
- initial
